//Κώδικας Εφαρμογής 5: Ηλεκτρονικό Ζάρι
//από το βιβλίο "Ανάπτυξη Εφαρμογών με το Arduino"
//Εκδόσεις Τζιόλα 
//Π. Παπάζογλου, Σ. Λιωνής

const int Button_Pin = 3;//pin κουμπιού
const int Debounce_Delay = 50;//αναμονή για ηρεμία
const int roll_delay = 2000;//καθυστέρηση ρίψης
const int LED_Pins[] = {5,7,4,6};//pins των LED
const int dice[6][4] = {{HIGH,LOW,LOW,LOW},//1
				  {LOW,HIGH,LOW,LOW},  //2
				  {HIGH,HIGH,LOW,LOW}, //3
				  {LOW,HIGH,HIGH,LOW}, //4
				  {HIGH,HIGH,HIGH,LOW},//5
				  {LOW,HIGH,HIGH,HIGH}};//6
//προηγούμενη κατάσταση κουμπιού
int Prev_Button_State = LOW;

void setup() 
{ 
 int i;

 for(i=0;i<4;i++)
 {
   pinMode(LED_Pins[i], OUTPUT);   
 } 
 pinMode(Button_Pin, INPUT);
 //αρχικοποίηση γεννήτριας ψευδοτυχαίων αριθμών
 randomSeed(analogRead(A0));
 Serial.begin(9600);//αρχικοποίηση σειριακής επικ.
}

void loop() 
{//ανάγνωση κατάστασης κουμπιού
 int Button_State = digitalRead(Button_Pin);
 //αν άλλαξε η κατάσταση, αναμονή για ηρεμία  
 if(Button_State != Prev_Button_State)
   delay(Debounce_Delay);
if((Button_State==HIGH)&&(Prev_Button_State==LOW))
 {//αν πατήθηκε το κουμπί κάλεσε τη roll
   roll();  
 }
 Prev_Button_State = Button_State;
}

void roll()//συνάρτηση ρίψης ζαριού
{
 int i; 
 int result = random(1,7);//τυχαίος αριθμός 1 - 6
 for(i=0;i<4;i++)//σβήσε όλα τα LED
 { 
   digitalWrite(LED_Pins[i], LOW);
 } 
 delay(roll_delay);//περίμενε 2 sec
 for (i=0;i<4;i++)//εμφάνισε το αποτέλεσμα
 {            //ανάβοντας τα κατάλληλα LED
   digitalWrite(LED_Pins[i],dice[result-1][i]);
 }
 Serial.println(result);//εμφάνιση στην κονσόλα
}

